/*******************************************************************/
/**    MAC 110 - Introdução à Computação                          **/
/**    IME-USP - Primeiro Semestre de 2011                        **/
/**    Turma: 045 - Professor: Fábio Kon                          **/
/**                                                               **/
/**    Terceiro Exercício-Programa -- ByteMaze                    **/
/**    Arquivo: Bar.java                                          **/
/**                                                               **/
/**    Rafael Marinaro Verona            7577323                  **/
/**    Ricardo Ferreira Guimarães        7577650                  **/
/**                                                               **/
/*******************************************************************/

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Class which represts a bar to be used on the interface (HUD).
 * 
 * @author Ricardo F. Guimarães and Rafael M. Verona
 * @1.0
 */
public class Bar  extends Actor
{
    private final int BAR_WIDTH = 300; //Largura
    private final int BAR_HEIGHT = 10; //Altura
    private final int MAX_VALUE; //Valor máximo
    private final java.awt.Color BAR_COLOR; //Cor
    
    private GreenfootImage mainBar; //Retângulo principal
    private GreenfootImage filledBar; //área preenchida
    
    /**
     * Constructor for objects of class Bar.
     * @param max maximum value of the bar
     * @param barColor color of the bar
     */
    public Bar(int max , java.awt.Color barColor)
    {
        MAX_VALUE = max;
        BAR_COLOR = barColor;
    }
    
    /**
     * Act - do whatever the BarraDeHP wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }
    
    /**
     * Updates the bar to show the actual value.
     * @param value value which will determine the size of the bar.
     */
    public void update(int value)
    {
        mainBar = new GreenfootImage(BAR_WIDTH + 2, BAR_HEIGHT+2); //Cria uma nova imagem
        
        filledBar = new GreenfootImage(BAR_WIDTH, BAR_HEIGHT - 1); //Cria outra imagem
        filledBar.setColor(BAR_COLOR); //Define a cor de desenho
        filledBar.drawRect(0, 0, (BAR_WIDTH * value) / MAX_VALUE, BAR_HEIGHT); //Desenha um retângulo
        filledBar.fillRect(0, 0, (BAR_WIDTH * value) / MAX_VALUE, BAR_HEIGHT); //Preenche o retângulo
        
        mainBar.drawImage(filledBar,1,1); //Cola uma imagem na outra
        mainBar.setColor(Color.WHITE); //Seleciona outra cor
        mainBar.drawRect(0, 0, BAR_WIDTH, BAR_HEIGHT); //Delimita as bordas
        
        setImage(mainBar); //Define a imagem do objeto
    }
}
