/*******************************************************************/
/**    MAC 110 - Introdução à Computação                          **/
/**    IME-USP - Primeiro Semestre de 2011                        **/
/**    Turma: 045 - Professor: Fábio Kon                          **/
/**                                                               **/
/**    Terceiro Exercício-Programa -- ByteMaze                    **/
/**    Arquivo: Central.java                                      **/
/**                                                               **/
/**    Rafael Marinaro Verona            7577323                  **/
/**    Ricardo Ferreira Guimarães        7577650                  **/
/**                                                               **/
/*******************************************************************/

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Class represents the Centrals, blocks which can be attacked and disabled by the Player,
 * upon disabled they give energy and reveal nearby enemies.
 * @author Ricardo F. Guimarães and Rafael M. Verona 
 * @version 1.0
 */
public class Central  extends Actor
{
    private final int CENTRAL_SCORE = 100; //Pontos dados pela central
    private final int TIME = 40; //Tempo de controle de troca de imagens (animação)
    private int count = Greenfoot.getRandomNumber(TIME); //Variável alterada a cada act
    private boolean option = true; //Indica qual deverá ser a imagem
    
    /**
     * Act - do whatever the Central wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (count == TIME) option = false; //Se o contador for igual ao intervalo de acts
        if (count == 0) option = true;
        
        if (option)
        {
            setImage ( new GreenfootImage("central0.png") );
            count++;
        }
        else 
        {
            setImage ( new GreenfootImage("central1.png") );
            count --;
        }
    }
    
    
    /**
     * Disable the current Central, giving energy to the player and revealing nearby enemies
     * @return points to be added to the score
     */
    public int disable()
    {
        Explosion exp = new Explosion(); //Cria animação que vai ser utilizada
        getWorld().addObject(exp, getX(), getY()); //Coloca a animação no mundo
        
        ((Level) (getWorld()) ).messageBox().update("Disabled an Central"); //Mostra uma mensagem
        List enemies = getObjectsInRange(75,Enemy.class); //Obtem uma lista dos inimigos ao redor
        ListIterator li = enemies.listIterator(); //Cria um iterador para a lista
        
        for (int i = 0; i < enemies.size(); i++)
            ( (Enemy) (li.next())).turnVisible(); //Torna visível todos os inimigos na Lista
            
        Wall w = new Wall("disabled.png"); //Coloca uma parede no lugar
        getWorld().addObject(w, getX(),getY());
        
        getWorld().removeObject(this); //Remove a Central
        return CENTRAL_SCORE; //Retorna os pontos que serão adicionados ao Score
    }
}
