/*******************************************************************/
/**    MAC 110 - Introdução à Computação                          **/
/**    IME-USP - Primeiro Semestre de 2011                        **/
/**    Turma: 045 - Professor: Fábio Kon                          **/
/**                                                               **/
/**    Terceiro Exercício-Programa -- ByteMaze                    **/
/**    Arquivo: Door.java                                         **/
/**                                                               **/
/**    Rafael Marinaro Verona            7577323                  **/
/**    Ricardo Ferreira Guimarães        7577650                  **/
/**                                                               **/
/*******************************************************************/

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * A block that can only be unlocked if the player has the right key.
 * 
 * @author Rafael M. Verona and Ricardo F. Guimarães
 * @version 1.0
 */
public class Door  extends Actor
{
    private int lock; //valor da chave
    
    private java.awt.Color iconColor; //cor da porta
    
    private final int WIDTH = 50, HEIGHT = 50; //tamanho da imagem
    
    /**
     * Constructor for objects of the class Door.
     * @param lockValue value of the lock (key required to open the door)
     * @param color color of the Door
     */
    public Door (int lockValue, java.awt.Color color)
    {
        lock = lockValue;
        iconColor = color;
        fillDoor();
    }
        
    /**
     * Act - do whatever the Door wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }
    
    /**
     * Fills the door with the specified color.
     */
    private void fillDoor()
    {
        GreenfootImage newImage = new GreenfootImage(WIDTH, HEIGHT); //Cria uma imagem
        newImage.setColor(iconColor); //Seleciona cor
        newImage.fill(); //Preenche a imagem
        newImage.drawImage(new GreenfootImage("door.png"),0,0); //Desenha o símbolo básico na imagem
        setImage(newImage); //Define a imagem
    }
    
    /**
     * Tests a given key, if the key is the right one, the door is opened.
     * @param key key to be tested.
     * @returns true if unlocked, else false.
     */
    public boolean tryOpen(int key)
    {
        if (key == lock) //Se for a chave certa
        {
            ((Level) (getWorld()) ).messageBox().update("Door unlocked"); //Mostra uma mensagem
            Floor f = new Floor("floor.png"); //Cria um novo Floor
            getWorld().addObject(f, getX(),getY()); //Coloca no mundo
            getWorld().removeObject(this); //Remove este objeto
            return true;
        }
        return false;
    }
}
