/*******************************************************************/
/**    MAC 110 - Introdução à Computação                          **/
/**    IME-USP - Primeiro Semestre de 2011                        **/
/**    Turma: 045 - Professor: Fábio Kon                          **/
/**                                                               **/
/**    Terceiro Exercício-Programa -- ByteMaze                    **/
/**    Arquivo: Enemy.java                                        **/
/**                                                               **/
/**    Rafael Marinaro Verona            7577323                  **/
/**    Ricardo Ferreira Guimarães        7577650                  **/
/**                                                               **/
/*******************************************************************/

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Class represents the Enemies, blocks which can be attacked and destroyed by the Player,
 * upon destroyed they give energy, can deal damage which is set in the constructor.
 * 
 * @author Ricardo F. Guimarães and Rafael M. Verona 
 * @version 1.0
 */
public class Enemy  extends Walkable
{   
    private final int SU_SCORE = 5; //Pontos a serem adicionados ao Score se for destruído  
    
    private final int TIME = 15; //Intervalo de acts entre troca de imagens
    private int count = Greenfoot.getRandomNumber(TIME); //Variável alterada a cada act
    private boolean option = true; //Indica qual deverá ser a imagem
    
    private int maxDamage; //Dano que o inimigo pode fazer
    
    private boolean visible = false; //Indica se está ou não visível
    
    /**
     * Constructor for objects of class Enemy.
     * @param value maximum damage of the enemy
     */
    public Enemy(int value)
    {
        maxDamage = value;
    }
    
    /**
     * Called when the Player take damage from an Enemy.
     * @return damage of the enemy
     */
    public int doDamage()
    {
        ((Level) (getWorld()) ).messageBox().update("Attacked by SU"); //Mostra uma mensagem
        return Greenfoot.getRandomNumber(maxDamage) + 1; //Retorna o dano entre 1 e o dano máximo
    }
    
    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (visible) //se está visível
        {
            if (count == TIME) option = false;
            if (count == 0) option = true;
            
            if (option)
            {
                setImage ( new GreenfootImage("enemy0.png") );
                count++;
            }
            else 
            {
                setImage ( new GreenfootImage("enemy1.png") );
                count --;
            }
        }
    }
    
    /**
     * Turns the enemy visible.
     */
    public void turnVisible()
    {
        visible = true;
    }
    
    /**
     * Destroy this Enemy.
     * @return points to be added to the score
     */
    public int die()
    {
        Explosion exp = new Explosion(); //Cria uma animação
        getWorld().addObject(exp, getX(), getY()); //Coloca a animação no mundo
        
        ((Level) (getWorld()) ).messageBox().update("Destroyed an SU"); //Mostra uma mensagem
        
        Floor f = new Floor("destroyed.png"); //Cria um objeto da classe Floor
        getWorld().addObject(f, getX(),getY()); //Coloca o objeto no mundo
        
        getWorld().removeObject(this); //Remove este inimigo
        
        return SU_SCORE * maxDamage; //Retorna os pontos que serão computados
    }
    
    
}
