/*******************************************************************/
/**    MAC 110 - Introdução à Computação                          **/
/**    IME-USP - Primeiro Semestre de 2011                        **/
/**    Turma: 045 - Professor: Fábio Kon                          **/
/**                                                               **/
/**    Terceiro Exercício-Programa -- ByteMaze                    **/
/**    Arquivo: Outdoor.java                                      **/
/**                                                               **/
/**    Rafael Marinaro Verona            7577323                  **/
/**    Ricardo Ferreira Guimarães        7577650                  **/
/**                                                               **/
/*******************************************************************/

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.io.*;
import java.net.URL;

/**
 * This class create an object from an image and put it on the screen, over everything,
 * When clicked, this object is removed.
 * 
 * @author Rafael M. Verona and Ricardo F. Guimarães
 * @version 1.0
 */
public class Outdoor extends Actor
{
    private boolean startPlayer = false; //Se deve colocar o player no mundo após desaparecer
    
    
    /**
     * Constructor for objects of class Outdoor.
     * 
     * @param imageFileName image to be shown on the screen
     * @param setPlayer true, if the player should be put on the world after this object be destroyed.
     * @author Rafael M. Verona and Ricardo F. Guimarães
     * @version 1.0
     */
    public Outdoor(String imageFileName, boolean setPlayer)
    {
        setImage( new GreenfootImage(imageFileName));
        startPlayer = setPlayer;
    }
    
    /**
     * Act - do whatever the Outdoor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() //Carregar uma imagem grande com um arquivo e uma imagem de fundo
    {
        if (Greenfoot.mouseClicked(this)) //Se foi clicado pelo mouse
        {
            if (startPlayer) //Se deve iniciar o player
            {
                Greenfoot.delay(1); //delay
                ( (Level) getWorld() ).addPlayer(); //Coloca o player no mundo
            }
            getWorld().removeObject(this); //Remove este objeto
        }
    }
}
    