/*******************************************************************/
/**    MAC 110 - Introdução à Computação                          **/
/**    IME-USP - Primeiro Semestre de 2011                        **/
/**    Turma: 045 - Professor: Fábio Kon                          **/
/**                                                               **/
/**    Terceiro Exercício-Programa -- ByteMaze                    **/
/**    Arquivo: Password.java                                     **/
/**                                                               **/
/**    Rafael Marinaro Verona            7577323                  **/
/**    Ricardo Ferreira Guimarães        7577650                  **/
/**                                                               **/
/*******************************************************************/

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * An class which represents a password, used to unlock doors
 * 
 * @author Ricardo F.Guimarães and Rafael M. Verona
 * @version 1.0
 */
public class Password  extends Walkable
{
    private int key; //Valor da chave
    private java.awt.Color iconColor; //Cor da chave
    private final int WIDTH = 23, HEIGHT = 35; //Tamanho da imagem
    
    /**
     * Constructor for objects of class Password.
     * @param value the value of the password.
     * @param color color of the icon's background.
     */
    public Password(int value, java.awt.Color color)
    {
        key = value;
        iconColor = color;
        fillKeyCard();
    }
    
    /**
     * Used when the player get a password, returns a value and moves the object
     * to the inventory.
     * 
     * @return the value of the password.
     */
    public int getKey()
    {
        GreenfootSound gotKeySfx =  new GreenfootSound("33233__HardPCM__Chip094.mp3");
        gotKeySfx.play(); //Reproduz efeito sonoro
        
        ((Level) (getWorld()) ).messageBox().update("Got key"); //Mostra uma mensagem
        
        Floor f = new Floor("floor.png"); //Cria um novo Floor
        getWorld().addObject(f, getX(),getY()); //Coloca no mesmo lugar
        setLocation(440 + (25 * key) , 580); //Move a chave para a posição adequada
        switchWalkable(false); //Não é mais um objeto onde o Player pode andar
        return key; //Retorna o valor da chave
    }
   
   /**
    * Prepare the Password image, according with its value.
    */
   private void fillKeyCard()
   {
        GreenfootImage newImage = new GreenfootImage(WIDTH, HEIGHT); //Cria uma nova imagem
        newImage.setColor(iconColor); //Define a cor
        newImage.fill(); //Preenche a imagem
        newImage.drawImage(new GreenfootImage("keycard.png"),0,0); //Cola o ícone padrão
        setImage(newImage); //Define a imagem
   }
    
    /**
     * Act - do whatever the Password wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
